diff --git a/pdns/packethandler.cc b/pdns/packethandler.cc
index 50b74b7..b25b565 100644
--- a/pdns/packethandler.cc
+++ b/pdns/packethandler.cc
@@ -1288,7 +1288,7 @@ DNSPacket *PacketHandler::questionOrRecurse(DNSPacket *p, bool *shouldRecurse)
       if((rr.qtype == p->qtype && !rr.auth) || (rr.qtype.getCode() == QType::NS && (!rr.auth || !pdns_iequals(sd.qname, rr.qname))))
         weHaveUnauth=1;
 
-      if(rr.qtype.getCode() == QType::CNAME && p->qtype.getCode() != QType::CNAME) 
+      if(rr.qtype.getCode() == QType::CNAME && p->qtype.getCode() != QType::CNAME && r->d.ra)
         weRedirected=1;
         
       if(rr.qtype.getCode() == QType::SOA && pdns_iequals(rr.qname, sd.qname)) { // fix up possible SOA adjustments for this zone
